# Contour maps

```julia
	# Purpose:    Make two contour maps based on the data in the file osu91a1f_16.nc
	# GMT progs:  gmtset, grdcontour, basemap, coast

    	gmtset(MAP_GRID_CROSS_SIZE_PRIMARY=0, FONT_ANNOT_PRIMARY=10, PS_CHAR_ENCODING="Standard+")
	
	basemap(limits=(0,16.5,0,19.0), frame=0, figscale=1)
	coast!(limits=:global360, proj=(name=:Hammer, center=0), frame=(ticks=30,),
	       resolution=:crude,  land=:lightbrown, water=:lightblue, figsize=15,
	       x_off=0.64, y_off=0.5)
	grdcontour!("@osu91a1f_16.nc", cont=10, annot=(int=50,labels=(font=7,)), labels=(dist=10,),
	            range=(-1000,-1), pen=((contour=1,pen="thinnest,-"), (annot=1, pen="thin,-")),
	            ticks=(gap=(0.25,0.05),))
	grdcontour!("@osu91a1f_16.nc", cont=10, annot=(int=50,labels=(font=7,)), labels=(dist=10,),
	            range=(-1,1000), ticks=(gap=(0.25,0.05),))

	coast!(limts=:d, proj=:Hammer, frame=(title="Low Order Geoid", ticks=30), res=:crude,
	       land=:lightbrown, water=:lightblue, y_off=8.5, figsize=15)
	grdcontour!("@osu91a1f_16.nc", cont=10, annot=(int=50,labels=(font=7,)), labels=(dist=10,),
	            range=(-1000,-1), pen=((contour=1,pen="thinnest,-"), (annot=1, pen="thin,-")),
	            ticks=(gap=(0.25,0.05),labels=""))
	grdcontour!("@osu91a1f_16.nc", cont=10, annot=(int=50,labels=(font=7,)), labels=(dist=10,),
	            range=(-1,100), ticks=(gap=(0.25,0.05),labels=""), show=true)
```

See also [`GMT ex01`](https://www.generic-mapping-tools.org/gmt/latest/gallery/ex01.html#example-01)