# Image presentations

```julia
	# Purpose:	Make two color images based gridded data
	# GMT progs:	gmtset, grd2cpt, grdgradient, grdimage, makecpt, colorbar, pstext

	gmtset(FONT_TITLE=30, MAP_ANNOT_OBLIQUE=0)
	g_cpt = makecpt(color=:rainbow, T=(-2,14,2))
	grdimage("@HI_geoid_02.nc", region=(bb=(160,220,20,30), diag=true),
	         proj=(name=:omercp, center=[190 25.5], parallels=[292 69]),
	         color=g_cpt, dpi=50, frame=(annot=10,), x_off=3.8, y_off=3.2, figsize=12)
	colorbar!(g_cpt, pos=(anchor=:RM, offset=(1.5,0), triangles=true, neon=true),
	          xaxis=(annot=2, label=:GEOID), yaxis=(label=:m,))
	t_cpt = grd2cpt("@HI_topo_02.nc", cmap=:relief, continuous=true)
	grdimage!("@HI_topo_02.nc", frame=(title="H@#awaiian@# T@#opo and @#G@#eoid@#", annot=10),
	          shade="+a0", dpi=50, color=t_cpt, y_off=11, par=(:MAP_TITLE_OFFSET, 1.25))
	colorbar!(t_cpt, pos=(anchor=:RM, offset=(1.5,0), neon=true), shade=0.3,
	          xaxis=(annot=2, label=:TOPO), yaxis=(label=:km,))
	T = text_record([-0.4 7.5; -0.4 3.0], ["a)", "b)"])
	text!(T, region=(0,21.6,0,29.94), attrib=(font=(30,"Helvetica-Bold"), justify=:CB),
	      y_off=12, proj=:linear, scale=1, show=1)
```

See also [`GMT ex02`](https://www.generic-mapping-tools.org/gmt/latest/gallery/ex02.html#example-02)