# A 3-D perspective mesh plot

```julia
    C = makecpt(cmap=(255,100), range=(-10,10,10), no_bg=true)

    grdcontour("@HI_geoid_04.nc", region=(195,210,18,25), view=(60,30), cont=1,
               annot=(int=5, labels=(rounded=true,)), labels=(dist=10,),
               x_off=3, y_off=3, proj=:merc, figscale=1.1)
    coast!(p=true, frame=(annot=2, axes=:NEsw), land=:black,
           rose=(inside=true, anchor=:BR, width=2.5, offset=0.25, label=true))
    grdview!("@HI_topo_04.nc", p=true, region=(195,210,18,25,-6,4),
             plane=(-6,:lightgray), surftype=(surf=true,mesh=true), Jz="0.9",
             frame=(axes=:wesnZ, annot=2), zaxis=(annot=2, label="Topo (km)"), y_off=5.6)
    text!(text_record([7.5 14.0], "H@#awaiian@# R@#idge@#"), region=(0,21,0,28),
          attrib=(font=(60,"ZapfChancery-MediumItalic"), justify=:CB),
          proj=:linear, view=:none, figscale=1, show=1)
```

See also [`GMT ex04`](https://www.generic-mapping-tools.org/gmt/latest/gallery/ex04.html#example-04)