# A 3-D illuminated surface

```julia
 	Gsombrero = gmt("grdmath -R-15/15/-15/15 -I0.3 X Y HYPOT DUP 2 MUL PI MUL 8 DIV COS EXCH NEG 10 DIV EXP MUL =");
	C = makecpt(color=128, range=(-5,5), no_bg=true);
	grdview(Gsombrero, limits=(-15,15,-15,15,-1,1), frame=(axes="SEwnZ", annot=5),
	        zaxis=(annot=0.5,), plane=(-1, :white), surftype=:surface,
			shade=(azim=225, norm="t0.75"), figsize=12, zsize=5, view=(120,30))

	title = text_record([7.5 12], "z(r) = cos (2@~p@~r/8) @~\\327@~e@+-r/10@+");
	pstext!(title, limits=(0,21,0,28), proj=:linear, view=:none,
	        attrib=(font=(50,"ZapfChancery-MediumItalic"), justify=:CB), scale=1, show=true)
```

See also [`GMT ex05`](https://www.generic-mapping-tools.org/gmt/latest/gallery/ex05.html#example-05)