# Plotting of histograms

```julia
	rose("@fractures_06.txt", limits=(0,1,0,360), swap_xy=true, sector="10r", radius=:n,
         fill=:orange, x_off=4, xaxis=(annot=0.2, grid=0.2), yaxis=(annot=30, grid=30),
         axis=(fill=:lightblue,), figsize=9, pen=1)

	histogram!("@v3206_06.txt", limits=(-6000,0,0,30), y_off=12, x_off=-1.0, pen=1,
               xaxis=(annot=2000, ticks=1000, label="Topography (m)"),
               yaxis=(annot=10, ticks=5, label=:Frequency, suffix=" %"),
               axis=(axes=:WSne, title=:Histograms, fill=:lightblue), fill=:orange,
               kind=(freq=true,), bin=250, proj=:linear, figsize=(12,6), show=true)
```

See also [`GMT ex06`](https://www.generic-mapping-tools.org/gmt/latest/gallery/ex06.html#example-06)