# A simple location map

```julia
    coast(region=(-50,0,-10,20), water=:lightblue, land="P300/26:FtanBdarkbrown",
          res=:low, shore=:thinnest, frame=(annot=10,), proj=:Mercator, figsize=18,
          par=(:FORMAT_GEO_MAP, :dddF))
    plot!("@fz_07.txt", pen="thinner,-")
    scatter!("@quakes_07.txt", h=1, i="0,1,2s0.01", marker=:circle, fill=:red,
             markerline=:thinnest, MarkerSize="3p")
    plot!("@isochron_07.txt", pen="thin,blue")
    plot!("@ridge_07.txt", pen=(:thicker,:orange))
    legend!(text_record("S 0.1i c 0.08i red thinnest 0.3i ISC Earthquakes"),
            pos=(inside=true, anchor=:TR, width=5.6, offset=0.5),
            box=(pen=:thick,inner=:thinner,fill=:white),
            par=(:FONT_ANNOT_PRIMARY, "18p,Times-Italic"))
    text!(text_record([-43 -5; -43 -8; -7 11], ["SOUTH", "AMERICA", "AFRICA"]),
          attrib=(font=(20,"Helvetica-Bold","white=thin"),), show=1)

```

See also [`GMT ex07`](https://www.generic-mapping-tools.org/gmt/latest/gallery/ex07.html#example-07)