# Time-series along tracks

```julia
    wiggle("@tracks_09.txt", limits=(185,250,-68,-42), proj=:Mercator, figscale=0.27,
           frame=(axes=:WSne, annot=10,ticks=5, fill=[240 255 240]), G="+red -G-blue",
           S="240/-67/500/@~m@~rad", scale=800, pen=:thinnest, par=(:FORMAT_GEO_MAP,:dddF))
    plot!("@ridge_09.txt", pen=:thicker)
    plot!("@fz_09.txt", pen="thinner,-")
    # Take label from segment header and plot near coordinates of last record of each track
    t = gmtconvert("@tracks_09.txt", E=:l)
    for k = 1:length(t)		t[k].text = [t[k].header]	end
    text!(t, attrib=(font=(8,"Helvetica-Bold"), angle=50, justify=:RM, horizontal=true),
          offset=(-0.1,-0.1), show=true)
```

See also [`GMT ex09`](https://www.generic-mapping-tools.org/gmt/latest/gallery/ex09.html#example-09)