# Gridding of data, continued

```julia
    contour("@table_5.11", region=(0,6.5,-0.2,6.5), frame=(axes=:WSen, annot=2, ticks=1),
            color="@ex_16.cpt", fill=true, figscale=1.143, y_off=14)
    text!(text_record([3.25 7], "pscontour (triangulate)"), noclip=true,
          font=(18,"Times-Roman"), justify=:CB)

    Graws0 = surface("@table_5.11", region=:same, inc=0.2)
    grdview!(Graws0, color="@ex_16.cpt", Q=:s, frame=:same, x_off=8.9)
    text!(text_record([3.25 7], "surface (tension = 0)"), noclip=true,
          font=(18,"Times-Roman"), justify=:CB)

    Graws5 = surface("@table_5.11", region=:same, inc=0.2, tension=0.5)
    grdview!(Graws5, color="@ex_16.cpt", Q=:s, frame=:same, x_off=-8.9, y_off=-9.5)
    text!(text_record([3.25 7], "surface (tension = 0.5)"), noclip=true,
          font=(18,"Times-Roman"), justify=:CB)

    Grawt = triangulate("@Table_5_11.txt", region=:same, inc=0.2, grid=true)
    Gfiltered = grdfilter(Grawt, distflag=0, F="c1")
    grdview!(Gfiltered, color="@ex_16.cpt", Q=:s, frame=:same, x_off=8.9)
    text!(text_record([3.25 7], "triangulate @~\\256@~ grdfilter"),
          no_clip=true, font=(18,"Times-Roman"), justify=:CB)
    text!(text_record([8.2 19], "Gridding of Data"), region=(0,10,0,10), no_clip=true,
          font=(32,"Times-Roman"), justify=:CB, figscale=1, proj=:linear, x_off=-8.9)
    colorbar!(D="x3.25i/0.35i+jTC+w5i/0.25i+h", color="@ex_16.cpt", y_off=-1.9, show=true)
```

See also [`GMT ex16`](https://www.generic-mapping-tools.org/gmt/latest/gallery/ex16.html#example-16)