# Custom plot symbols

```julia
    coast(region=:global360, xaxis=(annot=60,), yaxis=(annot=30,),
          title="Hotspot Islands and Hot Cities", land=:darkgreen,
          water=:lightblue, area=5000, proj=:Win, figsize=15)
    plot!("@hotspots.txt", symbol="kvolcano", markerline=:thinnest, fill=:red)

    # Overlay a few bullseyes at NY, Cairo, and Perth
    cities = [-74 40.45 1.0; 31.15 30.03 1.0; 115.49 -31.58 1.0; -56.16 -34.9 1.0]
    plot!(cities, S="k@bullseye", show=true)
```

See also [`GMT ex20`](https://www.generic-mapping-tools.org/gmt/latest/gallery/ex20.html#example-20)