# General vertical perspective projection

```julia
    lat = 41.5;	lon = -74;	alt = 160;	tilt = 0;	azim = 0;	twist = 0;	width = 0;	height = 0;
    coast(region=:global360, frame=(annot=5, grid=5), land=:lightbrown, water=:lightblue,
          shore=true, borders=((level=1,pen=(1,:red)), (level=2, pen=0.5)),
          proj=(name=:ortho, center=[lon, lat], parallels=[alt, azim, tilt, twist, width, height]),
          figsize=10, y_off=12, x_off=2.5)

    # Now point from an altitude of 160 km with a specific tilt and azimuth and with a wider restricted
    # view and a boresight twist of 45 degrees
    tilt=55;	azim=210;	twist=45;	width=30;	height=30;
    coast!(frame=:same, land=:lightbrown, water=:lightblue, shore=true,
           rivers=(level=:a, pen=:blue), res=:intermediate, borders=:a,
           proj=(name=:ortho, center=[lon, lat], parallels=[alt, azim, tilt, twist, width, height]),
           figsize=12, x_off=2.5, y_off=-10, show=1)
```

See also [`GMT ex26`](https://www.generic-mapping-tools.org/gmt/latest/gallery/ex26.html#example-26)