# Using country polygons for plotting and shading

```julia
    coast(region=(-6,20,35,52), DCW=(country="FR,IT", fill=(inv_pattern=8, dpi=300)),
          land=:lightgray, proj=:Mercator, figsize=11, x_off=5)
    # Extract a subset of ETOPO2m for this part of Europe
    makecpt(cmap=:globe, range=(-5000,5000,50), continuous=true)
    grdimage!("@FR+IT.nc", shade=(azim=15, norm="e0.75"), y_off=11,
              frame=(axes=:WsnE, annot=:auto, title="Franco-Italian Union, 2042-45"))
    coast!(DCW=(country="FR,IT", fill="red@60"), show=true)
    ```

See also [`GMT ex34`](https://www.generic-mapping-tools.org/gmt/latest/gallery/ex34.html#example-34)