# Spherical gridding using Renka’s algorithms

```julia
	# Interpolate data of Mars radius from Mariner9 and Viking Orbiter spacecrafts
	makecpt(cmap=:rainbow, range=(-7000,15000))
	# Piecewise linear interpolation; no tension
	Gtt = sphinterpolate("@mars370d.txt", region=:global, inc=1, tension=0, grid=true)
	grdimage(Gtt, proj=:Hammer, figsize=15, frame=(annot=:auto, grid=:auto), y_off=18)
	plot!("@mars370d.txt", marker=:circle, ms=0.1, fill=0,
          frame=(annot=30, grid=30), y_off=-8)
	# Smoothing
	Gtt = sphinterpolate("@mars370d.txt", region=:global, inc=1, tension=3, grid=true)
	grdimage!(Gtt, frame=(annot=30, grid=30), y_off=-8,  show=1)
    ```

See also [`GMT ex36`](https://www.generic-mapping-tools.org/gmt/latest/gallery/ex36.html#example-36)