# Day-light terminators and other sunlight parameters

```julia
    coast(limits=:global, frame=(annot=:a,ticks=:a,grid=:a), proj=:EckertVI,
          area=5000, shore=0.5, borders=(type=1, pen=(0.5,:gray)),
          water=[175 210 255], par=(:MAP_FRAME_TYPE, :plain), figsize=16)
    solar!(terminators=(term=:d, date="2016-02-09T16:00:00"), fill="navy@95")
    solar!(terminators=(term=:c, date="2016-02-09T16:00:00"), fill="navy@85")
    solar!(terminators=(term=:n, date="2016-02-09T16:00:00"), fill="navy@80")
    solar!(terminators=(term=:a, date="2016-02-09T16:00:00"), fill="navy@80")
    # Get Sun position at at that date and time an plot it.
    t = solar(sun=(date="2016-02-09T16:00:00",), formated=true)
    plot!(t, symbol="k@sunglasses/1.5", fill=:yellow, fmt=:png, show=true)
```

See also [`GMT ex46`](https://www.generic-mapping-tools.org/gmt/latest/gallery/ex46.html#example-46)